<?php
/*

		moziloGB - Functions.php
		
		moziloGB additional functions. 
		Feel free to change it to your personal purposes.
		
		mozilo 2007
		
*/

class Functions {
	
	var $gbsettings;

	
	function __construct($settings_prop) {
#		if (!file_exists($settings_prop))
#			die("Datei '$settings_prop' fehlt!");
		$this->gbsettings = $settings_prop;
	}

	function dataToEntry($content, $usefilter) {
        global $CHARSET;
		// HTML-Tags komplett entfernen
		$content = strip_tags($content);
		/* $content = preg_replace("/<[\/\!]*?[^<>]*?>/Usi","", $content); */
		$content = htmlentities($content,ENT_COMPAT,$CHARSET);
		// Zeilenwexxel und Pipe
		$content = preg_replace("/\[br\]/", "<br />", $content);
		$content = preg_replace("/\[pipe\]/", "|", $content);
		// Badword-Filter
		if ($usefilter)
			$content = $this->badWordFilter($content);
		// Mail- und Weblinks
		$content = $this->replaceUri($content);
		$content = $this->replaceMail($content);
		return $content;
	}
	
	function replaceUri($str) {
	  $pattern = '#(^|[^\"=]{1})(http://|ftp://|mailto:|news:)([^\s<>]+)([\s\n<>]|$)#sm';
	  return preg_replace($pattern,"\\1<a href=\"\\2\\3\" title=\"\\2\\3\" target=\"_blank\" rel=\"nofollow\">\\2\\3</a>\\4",$str);
	}
	
	function replaceMail($str) {
		return preg_replace("/^\w[\w|\.|\-]+@\w[\w|\.|\-]+\.[a-zA-Z]{2,4}$/", "<a href=\"mailto:$0\" title=\"$0\">$0</a>", $str);
	}
	
	function badWordFilter($str) {
		// "B�se-W�rter"-Array
		$badwords = explode(",", $this->gbsettings->get("badwords"));
		// Das "gute Wort"
		$goodword = $this->gbsettings->get("goodword");
		// Badword-RegEx zusammenbauen
		$regex = "/(";
		foreach ($badwords as $badword)
			$regex .= rtrim($badword)."|";
		$regex = substr($regex, 0, strlen($regex)-1).")/i";
		// ersetze durch "Gutes Wort"
		return preg_replace($regex, $goodword, $str);
	}
	
	function isBotSpam($str) {
		// Array von Bot-Phrasen
		$badwords = explode(",", $this->gbsettings->get("botwords"));
		// Badword-RegEx zusammenbauen
		$regex = "/(";
		foreach ($badwords as $badword)
			$regex .= rtrim($badword)."|";
		$regex = substr($regex, 0, strlen($regex)-1).")/i";

		// kommt eine Bot-Phrase vor?
		if (preg_match($regex, $str)) 
			return true;
		else
			return false;
	}
	
// ------------------------------------------------------------------------------
// E-Mail-Adressen verschleiern 
// ------------------------------------------------------------------------------
// Dank f�r spam-me-not.php an Rolf Offermanns! 
// Spam-me-not in JavaScript: http://www.zapyon.de
	function obfuscateAdress($originalString, $mode) {
		// $mode == 1			dezimales ASCII
		// $mode == 2			hexadezimales ASCII
		// $mode == 3			zuf�llig gemischt
		$encodedString = "";
		$nowCodeString = "";
		$randomNumber = -1;

		$originalLength = strlen($originalString);
		$encodeMode = $mode;
		
		for ( $i = 0; $i < $originalLength; $i++) {
			if ($mode == 3) $encodeMode = rand(1,2);
			switch ($encodeMode) {
				case 1: // Decimal code
					$nowCodeString = "&#" . ord($originalString[$i]) . ";";
					break;
				case 2: // Hexadecimal code
					$nowCodeString = "&#x" . dechex(ord($originalString[$i])) . ";";
					break;
				default:
					return "ERROR: wrong encoding mode.";
			}
			$encodedString .= $nowCodeString;
		}
		return $encodedString;
	}
}
?>