<?php

/*

		moziloGB - GBdatabase.php
		
		moziloGB functions for connecting to the guestbook's data base (in this case a flat file).
		Feel free to change it to your personal purposes.
		
		Arvid Zimmermann 2006 <moziloGB@azett.com>
		
*/


class GBdatabase {
	
	var $filename;
	var $entries;

	// constructor
	function __construct($filename) {
		$this->filename = $filename;
		$this->loadData();
	}
	
	// load data from file
	function loadData() {
		$this->entries = array();
		$filecontent = file($this->filename);
		foreach ($filecontent as $line) {
			array_push($this->entries, $this->entryStringToArray($line));
		}
	}
	
	// save data to file
	function saveData() {
		$filecontent = "";
		foreach ($this->entries as $i=>$entrydata) {
			$filecontent .= $this->entryArrayToString($entrydata);
		}
		$datafile = @fopen($this->filename,"w");
    @flock($datafile,2);
    @fwrite($datafile, $filecontent);
		@flock($datafile,3);
		fclose($datafile);
		$this->loadData();
	}
	
	// return all entries as array
	function returnEntriesAsArray() {
		$this->loadData();
		return $this->entries;
	}
	
	// add single entry
	function addEntry($entryarray) {
		array_push($this->entries, $entryarray);
		$this->saveData();
	}
	
	// return single entry
	function getEntry($number) {
		return $this->entries[$number];
	}
	
	// delete single entry
	function deleteEntry($number) {
		unset($this->entries[$number]);
		$this->saveData();
	}
	
	// add comment to single entry
	function commentEntry($number, $comment) {
		$this->entries[$number][7] = $comment;
		$this->saveData();
	}
	
	// change entry's string to array
	function entryStringToArray($entrystring) {
		return explode("|",rtrim($entrystring));
	}
	
	// change entry's array to string
	function entryArrayToString($entryarray) {
		$entrystring = "";
		for ($i = 0; $i < count($entryarray); $i++) {
			$entrystring .= $entryarray[$i]."|";
		}
		return substr($entrystring, 0, strlen($entrystring)-1)."\r\n";
	}

}
?>