<?php
/*

		moziloGB - ShowEntries.php
		
		moziloGB functions for preparing guestbook data for displaying. 
		Feel free to change it to your personal purposes.
		
		mozilo 2007
		
*/

class ShowEntries {

	var $gbfunctions;
	var $gbsettings;
	var $gbentries;
	var $gblanguage;
	
	
	// initialize settings variable
	function __construct($gbsettings, $gbentries, $gbfunctions, $gblanguage) {
		$this->gbfunctions = $gbfunctions;
		$this->gbsettings = $gbsettings;
		$this->gbentries = $gbentries;
		$this->gblanguage = $gblanguage;
	}
	
	// get all entries from file and return them
	function returnEntriesAsHtml() {
        global $smileys;
        global $URL_BASE;
        global $PLUGIN_DIR_NAME;
        global $CHARSET;
		$html = "";

		if (isset($_GET['gb']))
			$page = $_GET['gb'];
		else
			$page = 0;

		// get number of the guestbook's entries
		$countofentries = count($this->gbentries);
		// get entries per page setting
		$entriesperpage = $this->gbsettings->get("entriesperpage");
		// set $entriesperpage to max if "0" given
		if ($entriesperpage == 0)
			$entriesperpage = $countofentries;	

		// catch invalid values of "page"
		if(($page < 0) || ($page >= $countofentries/$entriesperpage)) {
			$page = 0;
		}
		
		// start at offset 0, if nothing given
		if($page == 0) {
			$start = 0;
			$end = $entriesperpage;
		}
		else {
			$start = $page * $entriesperpage;
			$end = $start + $entriesperpage;
		}

		// calculate reference pointer (points the $ref's element of the entries array later to know which entry to start from on the current page)
		$ref = $entriesperpage*(floor($countofentries/$entriesperpage)-$page)+($countofentries%$entriesperpage)-1;
		
        $html .= '<table class="entrytable" width="100%" cellspacing="0" border="0" cellpadding="0">';
		// build entries of chosen page
		for($i = $start; ($i < $end) && ($i < $countofentries); $i++) {
			$data = $this->gbentries[$ref];
			if($i > $countofentries or $data[0] < "0") {
			}
			else {
				$entrydate = strftime("%d.%m.%Y, %H:%M:%S", $data[0]);
				$entryip = $data[1];
				$entryhost = $data[2];
				$entryname = $this->gbfunctions->dataToEntry($data[3], false);
				$entrymail = $data[4];
				$entryhome = $data[5];
				$entrytext = $this->gbfunctions->dataToEntry($data[6], true); 
				$entrycomm = $this->gbfunctions->dataToEntry($data[7], false);
				
				// replace emoticons
				if($this->gbsettings->get("showsmileys") == "true") {
					$entrytext = $smileys->replaceEmoticons($entrytext);
					$entrycomm = $smileys->replaceEmoticons($entrycomm);
				}
				
				if ($this->gbsettings->get("showentrynumbers") == "true")
					$number = "#".($ref+1)." - ";
				else
					$number = "";
                $html .= "<tr>".
                '<td class="entrykopf">'.$number.' '.$entrydate.': '.$entryname." ";
				if($entrymail > "0") {
					$html .= "<a href=\"".$this->gbfunctions->obfuscateAdress("mailto:$entrymail", 3)."\" title=\"".$this->gbfunctions->obfuscateAdress("mailto:$entrymail", 3)."\"><img class=\"noborder\" src=\"".$URL_BASE.$PLUGIN_DIR_NAME."/moziloGB/design/mail.gif\" alt=\"".$this->gblanguage->getLanguageValue0GB("text_mail")."\" /></a> ";
				}
				if($entryhome > "0") {
					$entryhome = htmlentities($entryhome,ENT_COMPAT,$CHARSET);
					$html .= "<a href=\"".$entryhome."\" target=\"_blank\" title=\"".$entryhome."\" rel=\"nofollow\"><img class=\"noborder\" src=\"".$URL_BASE.$PLUGIN_DIR_NAME."/moziloGB/design/home.gif\" alt=\"".$this->gblanguage->getLanguageValue0GB("text_home")."\" /></a> ";
				}
				$html .= "</td></tr>";
				$html .= '<tr><td class="entrytd">'.$entrytext.'</td></tr>';
				if ($entrycomm != "")
					$html .= '<tr><td class="entrytd"><span class="commentator">'.$this->gblanguage->getLanguageValue0GB("text_comment")."</span> ".$entrycomm.'</td></tr>';
                $html .= '<tr><td class="entrytdbottom">&nbsp;</td></tr>';
				$ref--;
			}
		}
        $html .= "</table>";
		$total = count($this->gbentries);
		$seiten = ceil($total / $entriesperpage);
		
        $pagelinks = "<div class=\"gblinks\">".$this->gblanguage->getLanguageValue0GB("text_page")." ";
        global $CAT_REQUEST,$PAGE_REQUEST,$CatPage;

		for($j=0;$j<$seiten;$j++) {
			$ref = ($total - ($j * $entriesperpage)) - 1;
			if ($j == $page)
				$pagelinks .= ($j+1)." ";
			else {
                $pagelinks .= "<a href=\"".$CatPage->get_Href($CAT_REQUEST,$PAGE_REQUEST,$CatPage->get_Query("gb=".$j))."\">".($j+1)."</a> ";
            }
		}
		$pagelinks .= "</div>";
		if ($countofentries == 0)
			return $html;
		else
			return $pagelinks.'<br>'.$html.$pagelinks;
	}
}
?>